summaryrefslogtreecommitdiffstats
path: root/apache-websocket
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2013-07-23 22:00:14 +0000
committer Eric Hameleers <alien@slackware.com>2013-07-23 22:00:14 +0000
commit8cd952686944f6587c1e7c23bece523349724665 (patch)
tree605aa2102e134e0f163867c1e47497d7f6b6694e /apache-websocket
parent663894598b9103d2be2afb2e8d5aaafcc745cbd7 (diff)
downloadasb-8cd952686944f6587c1e7c23bece523349724665.tar.gz
asb-8cd952686944f6587c1e7c23bece523349724665.tar.xz
Initial revision
Diffstat (limited to 'apache-websocket')
-rwxr-xr-xapache-websocket/build/apache-websocket.SlackBuild228
-rw-r--r--apache-websocket/build/slack-desc19
2 files changed, 247 insertions, 0 deletions
diff --git a/apache-websocket/build/apache-websocket.SlackBuild b/apache-websocket/build/apache-websocket.SlackBuild
new file mode 100755
index 00000000..0b5d2001
--- /dev/null
+++ b/apache-websocket/build/apache-websocket.SlackBuild
@@ -0,0 +1,228 @@
+#!/bin/sh
+# $Id$
+# Copyright 2013 Eric Hameleers, Eindhoven, NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: apache-websocket
+# Descr: websocket module for apache
+# URL: https://github.com/abligh/apache-websocket
+# Needs:
+# Changelog:
+# 20130723-1: 23/Jul/2013 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh apache-websocket.SlackBuild' to build a Slackware package.
+# The package (.tgz) and .txt file as well as build logs are created in /tmp .
+# Install it using 'installpkg'.
+#
+# -----------------------------------------------------------------------------
+
+PRGNAM=apache-websocket
+VERSION=${VERSION:-20130723}
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:" -j4 "}
+TAG=${TAG:-alien}
+
+DOCS="LICENCE README*"
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE="$SRCDIR/${PRGNAM}-${VERSION}.tar.xz"
+#SRCURL=""
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Automatically determine the architecture we're building on:
+MARCH=$( uname -m )
+if [ -z "$ARCH" ]; then
+ case "$MARCH" in
+ i?86) export ARCH=i486 ;;
+ armv7hl) export ARCH=$MARCH ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$MARCH ;;
+ esac
+fi
+
+case "$ARCH" in
+ i486) SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ SLKLDFLAGS="-L/usr/lib"; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ armv7hl) SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ *) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+esac
+
+case "$ARCH" in
+ arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+ *) TARGET=$ARCH-slackware-linux ;;
+esac
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{configure,make,install,error,makepkg}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
+ if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE)"
+ wget -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE})' not available... aborting the build."
+ exit 1
+ fi
+fi
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+tar -xvf ${SOURCE}
+cd ${PRGNAM}-${VERSION}
+chown -R root:root .
+chmod -R u+w,go+r-w,a+X-s .
+
+echo Building ...
+cp vncproxy/mod_websocket_vnc_proxy.c .
+touch $OUTPUT/make-${PRGNAM}.log
+apxs -a -c mod_websocket.c 2>&1 | tee -a $OUTPUT/make-${PRGNAM}.log
+apxs -a -c mod_websocket_draft76.c 2>&1 | tee -a $OUTPUT/make-${PRGNAM}.log
+apxs -a -c mod_websocket_vnc_proxy.c 2>&1 | tee -a $OUTPUT/make-${PRGNAM}.log
+
+# Manually install stuff:
+LEXEC=$(apxs -q LIBEXECDIR)
+install -d -m 0755 $PKG/$LEXEC
+install -m755 .libs/mod_websocket.so $PKG/$LEXEC/mod_websocket.so
+install -m755 .libs/mod_websocket_draft76.so $PKG/$LEXEC/mod_websocket_draft76.so
+install -m755 .libs/mod_websocket_vnc_proxy.so $PKG/$LEXEC/mod_websocket_vnc_proxy.so
+
+# Add a proper apache include file:
+mkdir -p $PKG/etc/httpd/extra
+cat <<EOT > $PKG/etc/httpd/extra/apache-websocket.conf.new
+# In order to activate the module, your httpd.conf needs the following line:
+# Include /etc/httpd/extra/apache-websocket.conf
+# Read https://github.com/abligh/apache-websocket for configuration info.
+LoadModule websocket_module lib${LIBDIRSUFFIX}/httpd/modules/mod_websocket.so
+LoadModule websocket_draft76_module lib${LIBDIRSUFFIX}/httpd/modules/mod_websocket_draft76.so
+LoadModule websocket_vnc_proxy_module lib${LIBDIRSUFFIX}/httpd/modules/mod_websocket_vnc_proxy.so
+EOT
+
+# Add this to the doinst.sh:
+mkdir -p $PKG/install
+cat <<EOINS >> $PKG/install/doinst.sh
+# Handle the incoming configuration files:
+config() {
+ for infile in \$1; do
+ NEW="\$infile"
+ OLD="\`dirname \$NEW\`/\`basename \$NEW .new\`"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r \$OLD ]; then
+ mv \$NEW \$OLD
+ elif [ "\`cat \$OLD | md5sum\`" = "\`cat \$NEW | md5sum\`" ]; then
+ # toss the redundant copy
+ rm \$NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+ done
+}
+
+config etc/httpd/extra/apache-websocket.conf.new
+
+EOINS
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+
+# Restore the original umask:
+umask ${_UMASK_}
+
diff --git a/apache-websocket/build/slack-desc b/apache-websocket/build/slack-desc
new file mode 100644
index 00000000..917ea2bc
--- /dev/null
+++ b/apache-websocket/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler------------------------------------------------------|
+apache-websocket: apache-websocket (websockets module for apache)
+apache-websocket:
+apache-websocket: The apache-websocket module is an Apache 2.x server module
+apache-websocket: that may be used to process requests using the WebSocket
+apache-websocket: protocol (RFC 6455) by an Apache 2.x server.
+apache-websocket:
+apache-websocket: This package contains a forked and enjanced version (vnc proxy
+apache-websocket: module added) of https://github.com/disconnect/apache-websocket
+apache-websocket:
+apache-websocket: Home: https://github.com/abligh/apache-websocket
+apache-websocket: